%{

#ifndef	lint
#ifndef	DEBUG
static char SCCS_id[] = "@(#)inetd_check.l 2.1 90/08/02 19:22:25  Copyright(c) 1990 by Rational.";
#else
static char SCCS_id[] = "DEBUG @(#)inetd_check.l 2.1 90/08/02 19:22:25  Copyright(c) 1990 by Rational.";
#endif
#endif

#ifndef	X_OK
#include	<sys/file.h>
#endif
char	*rindex();
#define	DTIA		1
#define	SOMETHING_ELSE	2
%}
%%
^"dtia"			return	DTIA;
[^ \t\n]+		return	SOMETHING_ELSE;
[ \t\n]+		;
%%
static	char	*install_dir;
static	what_to_do() {
	fprintf(stderr,
	   "\n\tAdd to (or modify in) /etc/inetd.conf the following line:\n");
	fprintf(stderr,
	   "dtia\tstream\ttcp\tnowait\troot\t%s/in.dtia\tin.dtia\n\n",
		install_dir);
	exit(1);
}
static	check_equality(s)
char	*s; {
	if (strcmp(s,yytext)) {
		fprintf(stderr,
		"Expecting <%s> in dtia line in /etc/inetd.conf but got <%s>\n",
		s,yytext);
		what_to_do();
	}
}
static	check_path_name() {
	char	*tail;
	if (yytext[0] != '/') {
		fprintf(stderr,"%s must be an absolute pathname\n",yytext);
		what_to_do();
	}
	tail = rindex(yytext,'/');
	if ( (tail==NULL) || (strcmp(tail+1,"in.dtia")) ) {
		fprintf(stderr,"%s must end by in.dtia\n",yytext);
		what_to_do();
	}
	*tail = '\0';
	check_equality(install_dir);
	*tail = '/';
	if (access(yytext,F_OK) == -1) {
		fprintf(stderr,"%s: Not Accessible\n",yytext);
		what_to_do();
	} 
	if (access(yytext,X_OK) == -1) {
		fprintf(stderr,"%s: Not Executable\n",yytext);
		what_to_do();
	}
}
main(argc,argv) 
int	argc;
char	**argv; {
	int	item;
	if (argc-2)	exit(1);
	install_dir = argv[1];
	while ( (item = yylex()) == SOMETHING_ELSE )  ;
	if (item == DTIA) {
		item = yylex();
		/* Should be "stream"	*/
		check_equality("stream");
		item = yylex();
		/* Should be "tcp"	*/
		check_equality("tcp");
		item = yylex();
		/* Should be "nowait"	*/
		check_equality("nowait");
		item = yylex();
		/* Should be "root"	*/
		check_equality("root");
		item = yylex();
		/* Should be a valid file_name ended by "in.dtia"	*/
		check_path_name ();
		item = yylex();
		/* Should be "in.dtia" */
		check_equality("in.dtia");
	} else {
		/* Missing line in /etc/inetc.conf */
		fprintf(stderr,"Missing dtia line in /etc/inetd.conf\n");
		what_to_do();
	}
}
