
/* talk.h 2.1 90/08/02 19:04:04  Copyright(c) 1990 by Rational. */

#include	<stdio.h>
#include	<ctype.h>
#include	<errno.h>
#include	<fcntl.h>
#include	<grp.h>
#ifndef	APOLLO
#include	<malloc.h>
#endif
#include	<pwd.h>
#include	<setjmp.h>
#include	<signal.h>
#include	<string.h>
#ifdef ULTRIX_DTIA
#include	"types.h"
#else
#include	<sys/types.h>
#endif
#ifdef	APOLLO
#include	<sys/dir.h>
#else
#include	<dirent.h>
#endif
#include	<sys/file.h>
#include	<sys/param.h>
#include	<sys/stat.h>
#include	<sys/time.h>
#ifndef		SUN
#include	<time.h>
#endif
#include	<sys/wait.h>
#include	<sys/resource.h>
#ifdef	AIX
#include	<sys/select.h>
#endif
#include	<errno.h>

/* Internal Extension of <errno.h>	*/
#define	EALREADYEXISTS	10000

#define	MAX_SIZE_ITEM	2000

#define	R_CREATE	 	0
#define	R_PUT	 		1
#define	R_GET	 		2
#define	R_LAST_UPDATE	 	3
#define	R_FILE_EXISTS		4
#define	R_COPY	 		5
#define	R_DELETE		6
#define	R_MOVE			7
#define	R_LS	 		8
#define	R_INPUT_TO_SHELL	9
#define	R_SIGNAL_TO_SHELL	10
#define	R_EXPUNGE		11
#define	NB_REQUESTS	 	12

#define	F_DISCONNECT		0
#define	F_DELIMITOR		1
#define	F_ERROR			2
#define	F_IS_DIRECTORY	 	3
#define	F_REMOTE_FILE	 	4
#define	F_CONTENT	 	5
#define	F_TO_REMOTE_FILE	6
#define	F_FROM_REMOTE_FILE	7
#define	F_IN_SECONDS	 	8
#define	F_EXISTS		9
#define	F_TIME	 		10
#define	F_OF_REMOTE_FILE	11
#define	F_LINK	 		12
#define	F_EXPUNGE	 	13
#define	F_A_LINE	 	14
#define	F_FROM_REMOTE_DIRECTORY	15
#define	F_LEVEL	 		16
#define	F_INPUT			17
#define	F_SIGNAL		18
#define	F_STD_OUTPUT		19
#define	F_STD_ERROR		20
#define	F_ABORT			21
#define	F_CONTINUE		22
#define	F_TIMEOUT		23
#define	F_APPEND		24
#define	F_CREATE_DIR		25
#define	F_RECURSIVE		26
#define	F_OBJECT		27
#define	F_OPTIONS		28
#define	NB_FIELDS	 	29

#define	E_OK			0
#define	E_CONNECTION		1
#define	E_INTERNAL_ERROR	2
#define	E_BAD_USER		3
#define	E_ACCESS_ERROR	 	4
#define	E_DEVICE_ERROR	 	5
#define	E_LOCK_ERROR		6
#define	E_NAME_ERROR	 	7
#define	E_POLICY_ERROR	 	8
#define	E_STATUS_ERROR	 	9
#define	E_STORAGE_ERROR	 	10
#define	E_UNSUPPORTED		11
#define	E_USE_ERROR		12
#define	E_COMMAND_ERROR		13
#define	E_COMMAND_TERMINATED	14
#define	E_COMMAND_TIMED_OUT	15
#define	E_RESOURCE_LIMIT	16
#define	NB_ERRORS	 	17

#define	NIL_PLATFORM	0
#define	SUN_PLATFORM	1
#define	APOLLO_PLATFORM	2
#define	IBM_PLATFORM	3
#define	HP_PLATFORM	4
#define	ULTRIX_PLATFORM	6
#define	PLATFORM	NIL_PLATFORM
#ifdef	SUN
#undef	PLATFORM
#define	PLATFORM	SUN_PLATFORM
#endif
#ifdef	APOLLO
#undef	PLATFORM
#define	PLATFORM	APOLLO_PLATFORM
#endif
#ifdef	AIX
#undef	PLATFORM
#define	PLATFORM	IBM_PLATFORM
#endif
#ifdef	HP
#undef	PLATFORM
#define	PLATFORM	HP_PLATFORM
#endif

#ifdef	ULTRIX_DTIA
#undef	PLATFORM
#define	PLATFORM	ULTRIX_PLATFORM
#endif

#ifndef	TRUE
#define	TRUE	(0==0)
#endif
#ifndef	FALSE
#define	FALSE	(!TRUE)
#endif

#define	MAXTVSEC ((long)(100000000))
/* Limitation of the struct timeval	*/
/* tv_sec field				*/

#ifndef	SUN
#ifndef ULTRIX_DTIA
extern	long	timezone;
#endif
#endif

#ifndef	AIX
char	*strcpy();
char	*strncpy();
char	*strcat();
#ifdef	SUN
char	*sprintf();
#endif
#ifdef	HP
int	sprintf();
char	*getcwd();
#endif
char	*getwd();
char	*getenv();
char	*index();
char	*rindex();
#ifdef	APOLLO
char	*malloc();
struct	direct	*readdir();
#else
struct	dirent	*readdir();
#endif
#endif

#define	EXTERN	extern
#define	EXT

/* talk_connection*/
#undef	EXT
#ifndef	TALK_C
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	talk_connection();

/* check_id	*/
#undef	EXT
#ifndef	CHECK_ID
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	check_identity();
EXT	char	*get_user_home();
EXT	char	*get_user_shell();
EXT	int	is_bourne_shell();
EXT	int	is_cshell();
EXT	int	get_user_uid();
EXT	int	get_user_gid();


/* Interchange	*/
#undef	EXT
#ifndef	INTERCHANGE
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	short	Get_Bool();
EXT	void	Put_Bool();
EXT	short	Get_Short();
EXT	void	Put_Short();
EXT	int	Get_Int();
EXT	void	Put_Int();
EXT	void	Get_String();
EXT	void	Put_String();

/* Buffering	*/
#undef	EXT
#ifndef	BUFFERING
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	void	b_flush();
EXT	int	b_is_empty();
EXT	int	buff_read();
EXT	int	buff_write();

/* Read_Write	*/
#undef	EXT
#ifndef	READ_WRITE
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	rw_read_bool();
EXT	int	rw_read_short();
EXT	int	rw_read_int();
EXT	int	rw_read_str();
EXT	int	rw_read_bnd_str();
EXT	int	rw_write_bool();
EXT	int	rw_write_short();
EXT	int	rw_write_int();
EXT	int	rw_write_str();
EXT	int	rw_write_bnd_str();

/* Create	*/
#undef	EXT
#ifndef	CREATE_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	create_r_read();
EXT	int	create_r_write();
#undef	EXT
#ifndef	CREATE_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	create_f_is_directory_in();
EXT	int	create_f_create_directories_in();
EXT	int	create_f_remote_file_in();
EXT	int	create_f_options_in();
EXT	int	create_f_end();

/* Get		*/
#undef	EXT
#ifndef	GET_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	get_r_read();
EXT	int	get_r_write();
#undef	EXT
#ifndef	GET_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	get_f_from_remote_file_in();
EXT	int	get_f_options_in();
EXT	int	get_f_end_iter_i();
EXT	int	get_f_content_out();
EXT	int	get_f_end();

/* Put		*/
#undef	EXT
#ifndef	PUT_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	put_r_read();
EXT	int	put_r_write();
#undef	EXT
#ifndef	GET_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	put_f_to_remote_file_in();
EXT	int	put_f_append_in();
EXT	int	put_f_options_in();
EXT	int	put_f_content_in();
EXT	int	put_f_end();

/* Delete	*/
#undef	EXT
#ifndef	DELETE_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	delete_r_read();
EXT	int	delete_r_write();
#undef	EXT
#ifndef	DELETE_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	delete_f_remote_file_in();
EXT	int	delete_f_recursive_in();
EXT	int	delete_f_options_in();
EXT	int	delete_f_end();


/* Copy		*/
#undef	EXT
#ifndef	COPY_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	copy_r_read();
EXT	int	copy_r_write();
#undef	EXT
#ifndef	COPY_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	copy_f_link_in();
EXT	int	copy_f_from_remote_file_in();
EXT	int	copy_f_to_remote_file_in();
EXT	int	copy_f_options_in();
EXT	int	copy_f_end();

/* Move		*/
#undef	EXT
#ifndef	MOVE_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	move_r_read();
EXT	int	move_r_write();
#undef	EXT
#ifndef	MOVE_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	move_f_from_remote_file_in();
EXT	int	move_f_to_remote_file_in();
EXT	int	move_f_options_in();
EXT	int	move_f_end();

/* Last_Update	*/
#undef	EXT
#ifndef	LAST_UPDATE_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	last_update_r_read();
EXT	int	last_update_r_write();
#undef	EXT
#ifndef	LAST_UPDATE_W
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	last_update_f_of_remote_file_in();
EXT	int	last_update_f_options_in();
EXT	int	last_update_f_in_seconds_out();
EXT	int	last_update_f_end();

/* File_Existence	*/
#undef	EXT
#ifndef	FILE_EXISTS_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	file_exists_r_read();
EXT	int	file_exists_r_write();
#undef	EXT
#ifndef	FILE_EXISTS_W
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	file_exists_f_of_remote_file_in();
EXT	int	file_exists_f_file_exists_out();
EXT	int	file_exists_f_end();

/* Ls		*/
#undef	EXT
#ifndef	LS_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	ls_r_read();
EXT	int	ls_r_write();
#undef	EXT
#ifndef	LS_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	ls_f_from_remote_directory_in();
EXT	int	ls_f_level_in();
EXT	int	ls_f_end();

/* Input_To_Shell*/
#undef	EXT
#ifndef	INPUT_SH_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	input_to_shell_r_read();
EXT	int	input_to_shell_r_write();
#undef	EXT
#ifndef	INPUT_SH_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	input_to_shell_f_input_in();
EXT	int	input_to_shell_f_timeout_in();
EXT	int	input_to_shell_f_end();

/* Signal_To_Shell*/
#undef	EXT
#ifndef	SIGNAL_SH_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	signal_to_shell_r_read();
EXT	int	signal_to_shell_r_write();
#undef	EXT
#ifndef	SIGNAL_SH_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	signal_to_shell_f_signal_in();
EXT	int	signal_to_shell_f_end();

/* Remote_Shell	*/
#undef	EXT
#ifndef	REMOTE_SH
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	is_eof_reached();
EXT	int	kill_remote_shell();
EXT	int	signal_to_remote_shell();
EXT	int	set_remote_shell_masks_rw();
EXT	int	is_it_remore_shell_read();
EXT	int	read_remote_shell();
EXT	int	some_input_to_remote_shell();

/* Expunge	*/
#undef	EXT
#ifndef	EXPUNGE_R
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	expunge_r_read();
EXT	int	expunge_r_write();
#undef	EXT
#ifndef	CREATE_F
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	expunge_f_objects_in();
EXT	int	expunge_f_options_in();
EXT	int	expunge_f_end();

/* ERROR_STR	*/
#undef	EXT
#ifndef	ERROR_STR
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	report_err();

/* TRACE	*/
#undef	EXT
#ifndef	TRACE
#define	EXT	EXTERN
#else
#define	EXT
#endif
EXT	int	trace_request();
EXT	int	trace_bool();
EXT	int	trace_int();
EXT	int	trace_bnd_string();
EXT	int	trace_string();
EXT	int	trace_end();
EXT	int	trace_error();
