/* @(#)types.h	4.1.1.3	7/13/88 */

/************************************************************************
 *									*
 *			Copyright (c) 1986 by				*
 *		Digital Equipment Corporation, Maynard, MA		*
 *			All rights reserved.				*
 *									*
 *   This software is furnished under a license and may be used and	*
 *   copied  only  in accordance with the terms of such license and	*
 *   with the  inclusion  of  the  above  copyright  notice.   This	*
 *   software  or  any  other copies thereof may not be provided or	*
 *   otherwise made available to any other person.  No title to and	*
 *   ownership of the software is hereby transferred.			*
 *									*
 *   This software is  derived  from  software  received  from  the	*
 *   University    of   California,   Berkeley,   and   from   Bell	*
 *   Laboratories.  Use, duplication, or disclosure is  subject  to	*
 *   restrictions  under  license  agreements  with  University  of	*
 *   California and with AT&T.						*
 *									*
 *   The information in this software is subject to change  without	*
 *   notice  and should not be construed as a commitment by Digital	*
 *   Equipment Corporation.						*
 *									*
 *   Digital assumes no responsibility for the use  or  reliability	*
 *   of its software on equipment which is not supplied by Digital.	*
 *									*
 ************************************************************************/

/*
 *	Portions of this software have been licensed to 
 *	Digital Equipment Company, Maynard, MA.
 *	Copyright (c) 1986 Sun Microsystems, Inc.  ALL RIGHTS RESERVED.
 */

/*
 * Rpc additions to <sys/types.h>
 *
 *	History:
 *
 * 12-11-87	Robin L. and Larry C. and Ricky P.
 *	Added new kmalloc memory allocation to system.
 *
 * 12-18-87	Joe A.
 *	moved <sys/types> above kmalloc.h
 *
 * 02-19-91	R. Aggarwal
 *	customized for dtia porting - defs of TRUE, FALSE in #ifndef ULTRIX_DTIA
 */

#ifndef __RPC_TYPES.H__
#define __RPC_TYPES.H__

#ifndef	KERNEL
#ifndef major		/* ouch! */
#include <sys/types.h>
#endif
#include	<sys/kmalloc.h>
#else KERNEL
#include	"../h/kmalloc.h"
#endif KERNEL

#define	bool_t	int
#define	enum_t	int
#ifndef ULTRIX_DTIA
#define	FALSE	(0)
#define	TRUE	(1)
#endif
#ifndef NULL
#define NULL 0
#endif
#define __dontcare__	-1

#ifndef KERNEL
#define mem_alloc(dummy, dummy, bsize, dummy)	malloc(bsize)
#define mem_free(ptr, dummy)	free(ptr)
#else KERNEL
#define mem_alloc(ptr, cast, bsize, type)	KM_ALLOC((ptr), cast, bsize, type, KM_NOARG)
#define mem_free(ptr, type)                     KM_FREE((ptr), type)
#define kmem_alloc(ptr, cast, bsize, type)	KM_ALLOC((ptr), cast, bsize, type, KM_CLEAR)
#define kmem_free(ptr, type)	                KM_FREE((ptr), type)
#endif KERNEL
#endif __RPC_TYPES.H__
